from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Int, String, File

Du_V0_1_0 = CommandToolBuilder(tool="du", base_command=["du"], inputs=[ToolInput(tag="in_null", input_type=Boolean(optional=True), prefix="--null", doc=InputDocumentation(doc="end each output line with NUL, not newline")), ToolInput(tag="in_all", input_type=Boolean(optional=True), prefix="--all", doc=InputDocumentation(doc="write counts for all files, not just directories")), ToolInput(tag="in_apparent_size", input_type=Boolean(optional=True), prefix="--apparent-size", doc=InputDocumentation(doc="print apparent sizes, rather than disk usage; although\nthe apparent size is usually smaller, it may be\nlarger due to holes in ('sparse') files, internal\nfragmentation, indirect blocks, and the like")), ToolInput(tag="in_block_size", input_type=Int(optional=True), prefix="--block-size", doc=InputDocumentation(doc="scale sizes by SIZE before printing them; e.g.,\n'-BM' prints sizes in units of 1,048,576 bytes;\nsee SIZE format below")), ToolInput(tag="in_bytes", input_type=Boolean(optional=True), prefix="--bytes", doc=InputDocumentation(doc="equivalent to '--apparent-size --block-size=1'")), ToolInput(tag="in_total", input_type=Boolean(optional=True), prefix="--total", doc=InputDocumentation(doc="produce a grand total")), ToolInput(tag="in_dereference_args", input_type=Boolean(optional=True), prefix="--dereference-args", doc=InputDocumentation(doc="dereference only symlinks that are listed on the\ncommand line")), ToolInput(tag="in_max_depth", input_type=Int(optional=True), prefix="--max-depth", doc=InputDocumentation(doc="print the total for a directory (or file, with --all)\nonly if it is N or fewer levels below the command\nline argument;  --max-depth=0 is the same as\n--summarize")), ToolInput(tag="in_files_zero_from", input_type=Int(optional=True), prefix="--files0-from", doc=InputDocumentation(doc="summarize disk usage of the\nNUL-terminated file names specified in file F;\nif F is -, then read names from standard input")), ToolInput(tag="in_equivalent_dereferenceargs_d", input_type=Boolean(optional=True), prefix="-H", doc=InputDocumentation(doc="equivalent to --dereference-args (-D)")), ToolInput(tag="in_inodes", input_type=Boolean(optional=True), prefix="--inodes", doc=InputDocumentation(doc="list inode usage information instead of block usage")), ToolInput(tag="in_like__blocksizek", input_type=Boolean(optional=True), prefix="-k", doc=InputDocumentation(doc="like --block-size=1K")), ToolInput(tag="in_dereference", input_type=Boolean(optional=True), prefix="--dereference", doc=InputDocumentation(doc="dereference all symbolic links")), ToolInput(tag="in_count_links", input_type=Boolean(optional=True), prefix="--count-links", doc=InputDocumentation(doc="count sizes many times if hard linked")), ToolInput(tag="in_like__blocksizem", input_type=Boolean(optional=True), prefix="-m", doc=InputDocumentation(doc="like --block-size=1M")), ToolInput(tag="in_no_dereference", input_type=Boolean(optional=True), prefix="--no-dereference", doc=InputDocumentation(doc="don't follow any symbolic links (this is the default)")), ToolInput(tag="in_separate_dirs", input_type=Boolean(optional=True), prefix="--separate-dirs", doc=InputDocumentation(doc="for directories do not include size of subdirectories")), ToolInput(tag="in_si", input_type=Boolean(optional=True), prefix="--si", doc=InputDocumentation(doc="like -h, but use powers of 1000 not 1024")), ToolInput(tag="in_summarize", input_type=Boolean(optional=True), prefix="--summarize", doc=InputDocumentation(doc="display only a total for each argument")), ToolInput(tag="in_threshold", input_type=Int(optional=True), prefix="--threshold", doc=InputDocumentation(doc="exclude entries smaller than SIZE if positive,\nor entries greater than SIZE if negative")), ToolInput(tag="in_time_style", input_type=String(optional=True), prefix="--time-style", doc=InputDocumentation(doc="show times using STYLE, which can be:\nfull-iso, long-iso, iso, or +FORMAT;\nFORMAT is interpreted like in 'date'")), ToolInput(tag="in_exclude_from", input_type=File(optional=True), prefix="--exclude-from", doc=InputDocumentation(doc="exclude files that match any pattern in FILE")), ToolInput(tag="in_exclude", input_type=String(optional=True), prefix="--exclude", doc=InputDocumentation(doc="exclude files that match PATTERN")), ToolInput(tag="in_one_file_system", input_type=Boolean(optional=True), prefix="--one-file-system", doc=InputDocumentation(doc="skip directories on different file systems"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Du_V0_1_0().translate("wdl", allow_empty_container=True)

